local Buff_Count, DeBuff_Count, C_R, C_G, C_B, E_R, E_G, E_B = {}, {}, {}, {}, {}, {}, {}, {}

local function WLRF_BuffFilter(buffName, iconFilename, i, Check_Ending)
	-- Useless Filter
	if (string.match(buffName, "TargetingHit")) or (string.match(buffName, "Boon")) or (string.match(buffName, "No Magicka Regeneration")) or (Check_Ending <= 0) then
		WLRF_isValid = false
	else
		WLRF_isValid = true
	end
	return WLRF_isValid, buffName , iconFilename , i
end --function WLRF_BuffFilter(buffName, iconFilename, i)

local function WLRF_Buff_Update( changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType )
	
	if (WLRF_FIRSTLOAD == false) then WLRF_Loading() return end

	if (unitTag == nil) then return end
	if (WLRF_Save.disable_Buffs == false) then
			Buff_Count[unitTag] = 0
			DeBuff_Count[unitTag] = 0
			
			if (_G["WLRF_ANCHOR"..unitTag] ~= nil) then
				if (DoesUnitExist(unitTag) == true) then

					local nbuffs = GetNumBuffs( unitTag )

					local WLRF_count	= 1
					
					for i = 1, nbuffs, 1 do

						local buffName, timeStarted, timeEnding, buffSlot, stackcount, iconFilename, buffType, effectType, abilityType, statusEffectType, longTerm = GetUnitBuffInfo( unitTag , i )
						local Check_Ending = (timeEnding - (GetGameTimeMilliseconds() / 1000))
						
						WLRF_BuffFilter(buffName, iconFilename, i, Check_Ending)
						
						if (WLRF_isValid == true) then
							if (effectType == 1) then
								Buff_Count[unitTag] = Buff_Count[unitTag] + 1
							elseif (effectType == 2) then
								DeBuff_Count[unitTag] = DeBuff_Count[unitTag] + 1
							end
						end --if (WLRF_isValid == true) then
					end -- for i = 1, nbuffs, 1 do

					if (Buff_Count[unitTag] > 0) then
						E_R[unitTag], E_G[unitTag], E_B[unitTag] = 0.13, 0.8, 0.13
						_G["WLRF_ANCHOR"..unitTag]:SetEdgeColor(E_R[unitTag], E_G[unitTag], E_B[unitTag], 1)
					else
						_G["WLRF_ANCHOR"..unitTag]:SetEdgeColor(0.1,0.1,0.1,0)
					end

					if (DeBuff_Count[unitTag] > 0) then
						C_R[unitTag], C_G[unitTag], C_B[unitTag] = 0, 0, 0
						_G["WLRF_ANCHOR"..unitTag]:SetCenterColor(C_R[unitTag], C_G[unitTag], C_B[unitTag], 1)
					else
						_G["WLRF_ANCHOR"..unitTag]:SetCenterColor(0.1,0.1,0.1,0.25)
					end
				end --if (DoesUnitExist(unitTag) == true) then
			end --if (_G["WLRF_ANCHOR"..unitTag] ~= nil) then
			-- WLRF.ClearBuffIcons(WLRF_Owner, WLRF_count)
		-- end --for WLRF_Owner = 1, 24 do
	end --if (WLRF_Save.disable_Buffs == false) then
end --WLRF_Buff_Update

function WLRF_New_Buff( eventCode, changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType )
	if (unitTag == "player") then
		unitTag = WLRF_itIsPlayer
		WLRF_Buff_Update( changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType )
	elseif string.match(unitTag,"target") then
		return
	elseif string.match(unitTag,"over") then
		return
	elseif (unitTag == "") then
		return
	elseif (unitTag == nil) then
		return
	else
		WLRF_Buff_Update( changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType )
	end
end --WLRF_New_Buff()