-- Create Labels and List --
local WLRF_Enable_check_TEX = "/esoui/art/loot/loot_finesseitem.dds"
local WLRF_Enable_check_TEXBG = "/esoui/art/buttons/swatchframe_down.dds"
local BG_Alpha_Slider_BG_tex = "/esoui/art/unitframes/unitframe_player.dds"
local Scale_Slider_BG_tex = "/esoui/art/unitframes/unitframe_player.dds"
local Change_BG_Slider_BG_tex = "/esoui/art/unitframes/unitframe_player.dds"
local tex_HP_BG = "/esoui/art/campaign/overview_scoringbg_ebonheart_left.dds"
local tex = "/esoui/art/buttons/dropbox_arrow_disabled.dds"
local WLRF_Logo_Tex = "WarLegendGroupFrame/img/logo_wl.dds"

-- TOGGLE BUFFS -----
local function WLRF_toggle_Buffs()
	if (WLRF_Save.disable_Buffs == true) then
		WLRF_Save.disable_Buffs = false
		WLRF_Buffs_check:SetHidden(false)
	else
		WLRF_Save.disable_Buffs = true
		WLRF_Buffs_check:SetHidden(true)
		for i = 1, 24 do
			local Check_Frame = _G["WLRF_ANCHOR".."group"..i]

			if (Check_Frame ~= nil) then
				_G["WLRF_ANCHOR".."group"..i]:SetEdgeColor(0.1,0.1,0.1,0)
				_G["WLRF_ANCHOR".."group"..i]:SetCenterColor(0.1,0.1,0.1,0.25)
			end
		end
	end --if (WLRF_Save.disable_Buffs == true) then
end --function WLRF_toggle_Buffs()

-- TOGGLE RANGES -----
local function WLRF_toggle_Ranges()
	if (WLRF_Save.disable_Ranges == true) then
		WLRF_Save.disable_Ranges = false
		WLRF_Ranges_check:SetHidden(false)
		for i = 1, 24 do
			local Check_Frame = _G["WLRF_ANCHOR".."group"..i]

			if (Check_Frame ~= nil) then
				WLRF_PLAYER_HP["group"..i]:SetCenterColor(0.55,0.1,0,0.75)
				WLRF_PLAYER_HP["group"..i]:SetEdgeColor(0,0,0,0.75)
				
				WLRF_PLAYER_MA["group"..i]:SetCenterColor(0,0,0.6,0.75)
				WLRF_PLAYER_MA["group"..i]:SetEdgeColor(0,0,0.6,1)
				
				WLRF_PLAYER_ST["group"..i]:SetCenterColor(0,0.5,0,0.75)
				WLRF_PLAYER_ST["group"..i]:SetEdgeColor(0,0.5,0,1)
			end
		end
	else --if (WLRF_Save.disable_Ranges == true) then
		WLRF_Save.disable_Ranges = true
		WLRF_Ranges_check:SetHidden(true)
		for i = 1, 24 do
			local Check_Frame = _G["WLRF_ANCHOR".."group"..i]

			if (Check_Frame ~= nil) then
				if (IsUnitInGroupSupportRange("group"..i) == false) then
					WLRF_PLAYER_HP["group"..i]:SetCenterColor(0.25,0,0,0.75)
					WLRF_PLAYER_HP["group"..i]:SetEdgeColor(0,0,0,1)
					
					WLRF_PLAYER_MA["group"..i]:SetCenterColor(0,0,0.25,0.75)
					WLRF_PLAYER_MA["group"..i]:SetEdgeColor(0,0,0.25,1)
					
					WLRF_PLAYER_ST["group"..i]:SetCenterColor(0,0.25,0,0.75)
					WLRF_PLAYER_ST["group"..i]:SetEdgeColor(0,0.25,0,1)
				else
					WLRF_PLAYER_HP["group"..i]:SetCenterColor(0.55,0.1,0,0.75)
					WLRF_PLAYER_HP["group"..i]:SetEdgeColor(0,0,0,0.75)
					
					WLRF_PLAYER_MA["group"..i]:SetCenterColor(0,0,0.6,0.75)
					WLRF_PLAYER_MA["group"..i]:SetEdgeColor(0,0,0.6,1)
					
					WLRF_PLAYER_ST["group"..i]:SetCenterColor(0,0.5,0,0.75)
					WLRF_PLAYER_ST["group"..i]:SetEdgeColor(0,0.5,0,1)
				end
			end
		end
	end --if (WLRF_Save.disable_Ranges == true) then
end --function WLRF_toggle_Ranges()

local function WLRF_move_HPT_X()
	WLRF_Save.HPT_X = HPT_X_Slider:GetValue()
	HPT_X_Slider:SetValue(WLRF_Save.HPT_X)
	WLRF.Resfresh_Window()
end --WLRF_move_HPT_X()

local function WLRF_move_Scale_Slider()
	WLRF_Save.Scale = WLRF_Scale_Slider:GetValue()

	for i = 1,24 do

		if (WLRF_ANCHOR["group"..i] ~= nil) then

			if (i == 1) or (i == 2) or (i == 3) or (i == 4) then
				WLRF_CELL_X["group"..i] = 10 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (10 + ((i - 1) * 63)) * (WLRF_Save.Scale / 1)
			elseif (i == 5) or (i == 6) or (i == 7) or (i == 8) then
				WLRF_CELL_X["group"..i] = 175 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (10 + ((i - 5) * 63)) * (WLRF_Save.Scale / 1)
			elseif (i == 9) or (i == 10) or (i == 11) or (i == 12) then
				WLRF_CELL_X["group"..i] = 340 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (10 + ((i - 9) * 63)) * (WLRF_Save.Scale / 1)
			elseif (i == 13) or (i == 14) or (i == 15) or (i == 16) then
				WLRF_CELL_X["group"..i] = 10 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (265 + ((i - 13) * 63)) * (WLRF_Save.Scale / 1)
			elseif (i == 17) or (i == 18) or (i == 19) or (i == 20) then
				WLRF_CELL_X["group"..i] = 175 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (265 + ((i - 17) * 63)) * (WLRF_Save.Scale / 1)
			elseif (i == 21) or (i == 22) or (i == 23) or (i == 24) then
				WLRF_CELL_X["group"..i] = 340 * (WLRF_Save.Scale / 1)
				WLRF_CELL_Y["group"..i] = (265 + ((i - 21) * 63)) * (WLRF_Save.Scale / 1)
			end

			WLRF_ANCHOR["group"..i]:SetScale(WLRF_Save.Scale)
			WLRF_ANCHOR["group"..i]:SetAnchor(TOPLEFT, WLRF_MW_Anchor, TOPLEFT, WLRF_CELL_X["group"..i],WLRF_CELL_Y["group"..i])
		end
	end

	WLRF_Scale_Slider:SetValue(WLRF_Save.Scale)
	WLRF_Scale_SliderValue:SetText( math.floor(WLRF_Save.Scale * 100).." %" )
end --WLRF_move_Scale_Slider()

local function WLRF_reset_Position()
	WLRF_Save.Anchor_X = 0
	WLRF_Save.Anchor_Y = 40
	
	WLRF_MW_Anchor:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLRF_Save.Anchor_X,WLRF_Save.Anchor_Y)
	WLRF_Position_LBL:SetText( "|cFFA500WLRF Window position:\n|r"..
							"\t\t\t X = \t"..WLRF_Save.Anchor_X.."\n"..
							"\t\t\t Y = \t"..WLRF_Save.Anchor_Y )

	d ( "|cDC143CWarLegend Raid Frame|r position rested.")
end --WLRF_reset_Position()

local function WLRF_toggle_Colors()
	if (WLRF_Save.Class_Colors == true) then
		WLRF_Save.Class_Colors = false
		WLRF_Color_check:SetHidden(true)
		for i = 1, 24 do
			local Check_Frame = _G["WLRF_ANCHOR".."group"..i]

			if (Check_Frame ~= nil) then
				WLRF_PLAYER_LBL["group"..i]:SetColor(1, 1, 1)
			end
		end
	else
		WLRF_Save.Class_Colors = true
		WLRF_Color_check:SetHidden(false)
		for i = 1, 24 do
			local Check_Frame = _G["WLRF_ANCHOR".."group"..i]

			WLRF_PLAYER_CLASS["group"..i] = GetUnitClass("group"..i)

			if (Check_Frame ~= nil) then
				if (WLRF_PLAYER_CLASS["group"..i] == "Nightblade") then
					WLRF_PLAYER_LBL["group"..i]:SetColor(1, 0.412, 0.706)
				elseif (WLRF_PLAYER_CLASS["group"..i] == "Sorcerer") then
					WLRF_PLAYER_LBL["group"..i]:SetColor(0, 0.498, 1)
				elseif (WLRF_PLAYER_CLASS["group"..i] == "Dragonknight") then
					WLRF_PLAYER_LBL["group"..i]:SetColor(1, 0.498, 0)
				elseif (WLRF_PLAYER_CLASS["group"..i] == "Templar") then
					WLRF_PLAYER_LBL["group"..i]:SetColor(0.988, 0.862, 0.07)
				end
			end
		end
	end --if (WLRF_Save.Class_Colors == true) then
end --WLRF_toggle_Colors()

--[[----------------------------------------------------------
	INITIALIZATION
  ]]----------------------------------------------------------
function WLRF.InitializeSettings()
	--Settings Window
	WLRF_SettingsMW = WLRF.Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLRF_SettingsMW"))
		:SetDimensions(500,400)
		:SetAnchor(TOP,GuiRoot,TOP,0,400)
		:SetDrawLayer(0)
	.__END
	
	WLRF_SettingsMW_BG = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_SettingsMW_BG", WLRF_SettingsMW, CT_BACKDROP))
		:SetAnchorFill(WLRF_SettingsMW)
		:SetCenterColor(0.1,0.1,0.1,1)
		:SetEdgeColor(0,0,0,1)
		:SetEdgeTexture("", 8, 1, 1)
		:SetAlpha(0.75)
		:SetDrawLayer(1)
	.__END
	
	WLRF_SettingsMW_Title = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_SettingsMW_Title", WLRF_SettingsMW, CT_LABEL))
		:SetFont("ZoFontBookTablet")
		:SetColor(255,255,255,255)
		:SetText("|cFFCC00WarLegend Raid Frame|r")
		:SetAnchor(TOP,WLRF_SettingsMW,TOP,0,0)
		:SetDrawLayer(2)
	.__END
	
	WLRF_SettingsMW_Version = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_SettingsMW_Version", WLRF_SettingsMW, CT_LABEL))
		:SetFont("ZoFontAnnounceSmall")
		:SetColor(255,255,255,255)
		:SetText("v"..WLRF_VERSION)
		:SetAnchor(TOPRIGHT,WLRF_SettingsMW,TOPRIGHT,-5,30)
		:SetDrawLayer(2)
	.__END
	
	-- Close Button ------
	WLRF_SettingsMW_close = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_SettingsMW_close", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(60,50)
		:SetAnchor(BOTTOMRIGHT, WLRF_SettingsMW ,BOTTOMRIGHT, -5,15)
		:SetFont("ZoFontAnnounceMedium")
		:SetText("Close")
		:SetDrawLayer(3)
		:SetScale(0.80)
		:SetMouseOverFontColor(0.8,0.4,0,1)
		:SetHandler("OnClicked", function(self) WLRF_SettingsMWClose(self) end)
	.__END
	
	-- Enable BUFFS -----
	-- WLRF_Enable_Buffs = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Enable_Buffs", WLRF_SettingsMW, CT_BUTTON))
	-- 	:SetDimensions(310,40)
	-- 	:SetFont("ZoFontCallout")
	-- 	:SetText( "Enable Buffs Display" )
	-- 	:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,250,165)
	-- 	:SetDrawLayer(3)
	-- 	:SetScale(0.5)
	-- 	:SetNormalFontColor(1,1,1,0.8)
	-- 	:SetMouseOverFontColor(1,0.65,0,1)
	-- 	:SetHandler("OnClicked",function(self) WLRF_toggle_Buffs() end)
	-- .__END
	
	-- WLRF_Buffs_check = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Buffs_check", WLRF_SettingsMW, CT_TEXTURE ))
	-- 	:SetTexture(WLRF_Enable_check_TEX)
	-- 	:SetColor(0,1,0,1)
	-- 	:SetDimensions(20,20)
	-- 	:SetDrawLayer(3)
	-- 	:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,435,165)
	-- .__END
	
	-- WLRF_Buffs_checkBG = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Buffs_checkBG", WLRF_SettingsMW, CT_TEXTURE ))
	-- 	:SetTexture(WLRF_Enable_check_TEXBG)
	-- 	:SetColor(1,1,1,1)
	-- 	:SetDimensions(20,20)
	-- 	:SetDrawLayer(2)
	-- 	:SetAnchor(CENTER,WLRF_Buffs_check,CENTER,0,0)
	-- .__END
	
	-- WLRF_Buffs_Button = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Buffs_Button", WLRF_SettingsMW, CT_BUTTON))
	-- 	:SetDimensions(20,20)
	-- 	:SetAnchor(CENTER,WLRF_Buffs_check,CENTER,0,0)
	-- 	:SetDrawLayer(5)
	-- 	:SetHandler("OnClicked",function(self) WLRF_toggle_Buffs() end)
	-- .__END

	-- Enable Range -----
	WLRF_Enable_Ranges = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Enable_Ranges", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(310,40)
		:SetFont("ZoFontCallout")
		:SetText( "Enable Check Range" )
		:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,249,195)
		:SetDrawLayer(3)
		:SetScale(0.5)
		:SetNormalFontColor(1,1,1,0.8)
		:SetMouseOverFontColor(1,0.65,0,1)
		:SetHandler("OnClicked",function(self) WLRF_toggle_Ranges() end)
	.__END
	
	WLRF_Ranges_check = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Ranges_check", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(WLRF_Enable_check_TEX)
		:SetColor(0,1,0,1)
		:SetDimensions(20,20)
		:SetDrawLayer(3)
		:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,435,195)
	.__END
	
	WLRF_Ranges_checkBG = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Ranges_checkBG", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(WLRF_Enable_check_TEXBG)
		:SetColor(1,1,1,1)
		:SetDimensions(20,20)
		:SetDrawLayer(2)
		:SetAnchor(CENTER,WLRF_Ranges_check,CENTER,0,0)
	.__END
	
	WLRF_Ranges_Button = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Ranges_Button", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(20,20)
		:SetAnchor(CENTER,WLRF_Ranges_check,CENTER,0,0)
		:SetDrawLayer(5)
		:SetHandler("OnClicked",function(self) WLRF_toggle_Ranges() end)
	.__END

	-- Enable Colors -----
	WLRF_Enable_Color = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Enable_Color", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(310,40)
		:SetFont("ZoFontCallout")
		:SetText( "Enable Class Colors" )
		:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,247,225)
		:SetDrawLayer(3)
		:SetScale(0.5)
		:SetNormalFontColor(1,1,1,0.8)
		:SetMouseOverFontColor(1,0.65,0,1)
		:SetHandler("OnClicked",function(self) WLRF_toggle_Colors() end)
	.__END
	
	WLRF_Color_check = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Color_check", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(WLRF_Enable_check_TEX)
		:SetColor(0,1,0,1)
		:SetDimensions(20,20)
		:SetDrawLayer(3)
		:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,435,225)
	.__END
	
	WLRF_Color_checkBG = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Color_checkBG", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(WLRF_Enable_check_TEXBG)
		:SetColor(1,1,1,1)
		:SetDimensions(20,20)
		:SetDrawLayer(2)
		:SetAnchor(CENTER,WLRF_Color_check,CENTER,0,0)
	.__END
	
	WLRF_Color_Button = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Color_Button", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(20,20)
		:SetAnchor(CENTER,WLRF_Color_check,CENTER,0,0)
		:SetDrawLayer(5)
		:SetHandler("OnClicked",function(self) WLRF_toggle_Colors() end)
	.__END
	
	-- Position Main Window -----
	WLRF_Position_LBL = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Position_LBL", WLRF_SettingsMW, CT_LABEL))
		:SetFont("ZoFontGame")
		:SetColor(255,255,255,255)
		:SetText( "|cFFA500WLRF Window position:\n|r"..
					"\t\t\t X = \t"..WLRF_Save.Anchor_X.."\n"..
					"\t\t\t Y = \t"..WLRF_Save.Anchor_Y )
		:SetAnchor(TOPLEFT,WLRF_SettingsMW,TOPLEFT,10,130)
	.__END
	
	WLRF_Reset_Pos_B = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Reset_Pos_B", WLRF_SettingsMW, CT_BUTTON))
		:SetDimensions(150,50)
		:SetAnchor(TOPLEFT, WLRF_SettingsMW ,TOPLEFT, 5,200)
		:SetFont("ZoFontAnnounceMedium")
		:SetText("Reset Position")
		:SetScale(0.75)
		:SetDrawLayer(3)
		:SetNormalFontColor(1,1,1,0.8)
		:SetMouseOverFontColor(1,0.65,0,1)
		:SetHandler("OnClicked", function(self) WLRF_reset_Position() end)
	.__END
	
	--Scale -----
	WLRF_Scale_SliderLabel = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Scale_SliderLabel", WLRF_SettingsMW, CT_LABEL))
		:SetFont("ZoFontGame")
		:SetColor(255,255,255,255)
		:SetText( "|cFFA500 Choose Cell Size|r" )
		:SetAnchor(TOP,WLRF_SettingsMW,TOP,0,60)
	.__END
	
	WLRF_Scale_Slider_BG = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Scale_Slider_BG", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(Scale_Slider_BG_tex)
		:SetColor(1,1,1,1)
		:SetDrawLayer(1)
		:SetDimensions(320,20)
		:SetAnchor(TOP,WLRF_SettingsMW,TOP,-10,85)
	.__END
	
	WLRF_Scale_SliderValue = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Scale_SliderValue", WLRF_SettingsMW, CT_LABEL))
		:SetFont("ZoFontGame")
		:SetColor(255,255,255,255)
		:SetText( math.floor(WLRF_Save.Scale * 100).." %" )
		:SetAnchor(TOP,WLRF_SettingsMW,TOP,100,60)
	.__END
	
	WLRF_Scale_Slider = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Scale_Slider", WLRF_SettingsMW, CT_SLIDER))
		:SetMouseEnabled(true)
		:SetDimensions(300, 20)
		:SetThumbTexture(tex,tex,tex,20,25,1,1,0,0)
		:SetMinMax(0.75,1.16)
		:SetOrientation(1)
		:SetValueStep(0.01)
		:SetAnchor(TOP,WLRF_SettingsMW,TOP,0,85)
		:SetValue(WLRF_Save.Scale)
		:SetDrawLayer(4)
		:SetHandler( "OnValueChanged" , function(self) WLRF_move_Scale_Slider() end)
	.__END

	WLRF_Logo = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Logo", WLRF_SettingsMW, CT_TEXTURE ))
		:SetTexture(WLRF_Logo_Tex)
		:SetColor(1,1,1,1)
		:SetDimensions(320,80)
		:SetDrawLayer(3)
		:SetAnchor(BOTTOMLEFT,WLRF_SettingsMW,BOTTOMLEFT,-50,15)
	.__END
	
	WLRF.Toggle_Settings()
end

-- TOGGLEETTINGS
function WLRF.Toggle_Settings()
	WLRF_MOVE = true

	WLRF_Raid_MW:SetHidden(false)
	WLRF_MW_Anchor:SetHidden(false)

	-- WLRF_Buffs_check:SetHidden(WLRF_Save.disable_Buffs)
	WLRF_Ranges_check:SetHidden(WLRF_Save.disable_Ranges)
	WLRF_Color_check:SetHidden(not WLRF_Save.Class_Colors)

	WLRF_SettingsMW:SetHidden(false)

	WLRF_Position_LBL:SetText( "|cFFA500WLRF Window position:\n|r"..
							"\t\t\t X = \t"..WLRF_Save.Anchor_X.."\n"..
							"\t\t\t Y = \t"..WLRF_Save.Anchor_Y )
	WLRF_Scale_Slider:SetValue(WLRF_Save.Scale)
	WLRF_Scale_SliderValue:SetText( math.floor(WLRF_Save.Scale * 100).." %" )
end

-- CLOSE BUTTON -----
function WLRF_SettingsMWClose(self)
	WLRF_SettingsMW:SetHidden(true)
	WLRF_MW_Anchor:SetHidden(true)
	SetGameCameraUIMode(false)
	d ( "|cDC143CWarLegend Raid Frame|r Settings saved...")
	WLRF_MOVE = false
end

